<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2004 Mximo Cuadros Ortiz - Gobernalia Global Net S.A. (Grupo BBVA) (maximo.cuadros@grupobbva.com)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Plugin 'Dummy' for the 'gb_customhome' extension.
 *
 * @author	Mximo Cuadros Ortiz - Gobernalia Global Net S.A. (Grupo BBVA) <maximo.cuadros@grupobbva.com>
 */

error_reporting(E_WARNING);
require_once(PATH_tslib."class.tslib_pibase.php");


class ux_t3lib_DB extends t3lib_DB {
	function parseConfGB($conf) {
		//Get the list of affected uids 
		$salida['uids']=explode("/",$conf['customize']);
		
		//Get the list of affected cols
		$tmp=explode("/",$conf['customizeCols']);
		$i=0; $max=count($tmp);
		while ($i < $max){
			$tmp2=explode(",",$tmp[$i]);
			$salida['cols'][]=$tmp2[0];
			$salida['colsNames'][$tmp2[0]]=$tmp2[1];
			$i++;
		}

		return $salida;
	}
	function SELECTquery($select_fields,$from_table,$where_clause,$groupBy='',$orderBy='',$limit='')        {
		
		if ( $from_table == "tt_content" && is_numeric($GLOBALS["TSFE"]->fe_user->user['uid']) ) { 
	
			//Get the setup typoscripts vars
			$conf=$this->parseConfGB($GLOBALS['TSFE']->tmpl->setup['plugin.']['tx_gbcustomhome_pi1.']);
			$uids=$conf['uids'];
			$cols=$conf['cols'];
			
	
			
			//If the id of the pages not is on the array do nothing
			if ( in_array($GLOBALS['TSFE']->id,$uids) ) {
				//Extract the colPos from the sql this is a crap but.... if any find a best way msg me.
				$where_clauseLimpia=str_replace(" ","",$where_clause);
				$tmp=explode("colPos=",$where_clauseLimpia);
				$colPos=substr($tmp[1],0,1);	
				
				if ( strlen($colPos) == 0 ) { 
					$colPos=0;
					if ( $_GET['debug'] == 1 ) { echo "colPos not find on the query, using colPos 0 for this query<hr>";}
				}
				
				//Check if this colPos its enable for customizacion if not do nothing
				if ( in_array($colPos,$cols) ) {
					//Check if this page was customized if not do nothing
					$sqlCustomized="SELECT count(*) FROM `tx_gbcustomhome_tt_content_users` WHERE colPosition = $colPos AND pid = ".$GLOBALS['TSFE']->id." AND cruser_id = ".$GLOBALS["TSFE"]->fe_user->user['uid'];
					$res=mysql_query($sqlCustomized);
					$customized = mysql_fetch_array($res);
					$canDebug=true;
					//Change the sql with a join with the table tx_gbcustomhome_tt_content_users if exist info about customization for this user
					if ( $customized[0] > 0 ) {
				
						//$from_table .=",tx_gbcustomhome_tt_content_users";
						$from_table .=" LEFT JOIN tx_gbcustomhome_tt_content_users ON tx_gbcustomhome_tt_content_users.tt_content = tt_content.uid";
						$orderBy = "tx_gbcustomhome_tt_content_users.sorting , tt_content.sorting";
						$where_clause .=" AND ( (  tx_gbcustomhome_tt_content_users.cruser_id = ".$GLOBALS["TSFE"]->fe_user->user['uid'].") OR tt_content.tx_gbcustomhome_fixed = 0 ) "; 
						
					} else {
                        $where_clause .=" AND tt_content.tx_gbcustomhome_fixed != 1 ";

                    }
				}
			}
			
			
		}  elseif ( $from_table == "tt_content" ) {
            $where_clause .=" AND tt_content.tx_gbcustomhome_fixed != 1 ";
        }
                                                    
		
		$salida =  parent::SELECTquery($select_fields,$from_table,$where_clause,$groupBy,$orderBy,$limit);

		if ( $canDebug == true & $_GET['debug'] == 1 ) { echo $salida ."<hr>"; echo $sqlCustomized ."<hr>"; }
		
		return $salida;
	}
}

class tx_gbcustomhome_pi1 extends tslib_pibase {
	var $prefixId = "tx_gbcustomhome_pi1";		// Same as class name
	var $scriptRelPath = "pi1/class.tx_gbcustomhome_pi1.php";	// Path to this script relative to the extension dir.
	var $extKey = "gb_customhome";	// The extension key.
	
	function showCombos($colPos,$customize,$template) {
	
		//Save the info if get ones
		$this->saveCombo($colPos,$customize);
		
		
		// the width of the selects
		if ( !is_numeric($this->conf['width']) ) { $this->conf['width']="150"; }
		
		$res=mysql_query("SELECT tt_content.tx_gbcustomhome_title,tt_content.uid FROM tt_content WHERE tt_content.tx_gbcustomhome_fixed != 0 AND tt_content.pid IN ($customize) AND colPos=$colPos AND sys_language_uid IN (0) ".$this->cObj->enableFields("tt_content")." ORDER BY tt_content.sorting");
		while ($row=mysql_fetch_array($res)) {
			if ( strlen(trim($row['tx_gbcustomhome_title'])) == 0 ) { $row['tx_gbcustomhome_title']="ERROR!!! Not title setup for this object"; }
			$optiones[$row['uid']]=$row['tx_gbcustomhome_title'];
			$options .= "<option value='".$row['uid']."'>".$row['tx_gbcustomhome_title']."</option>";
		
		}
		$res=mysql_query("SELECT tt_content FROM `tx_gbcustomhome_tt_content_users` WHERE colPosition = $colPos AND pid = $customize AND cruser_id = ".$this->userInfo['uid']. " ORDER BY tx_gbcustomhome_tt_content_users.sorting");
		while ($row=mysql_fetch_array($res)) {
			$options2 .= "<option value='".$row['tt_content']."'>".$optiones[$row['tt_content']]."</option>";
		
		}
		$comboOptions="		
		<select style=\"width:".$this->conf['width']."px;\" name=\"formulario[$colPos][setupForm]_sel\" size=10 OnChange=\"setFormValueFromBrowseWin('formulario[$colPos][setupForm]',this.options[this.selectedIndex].value,this.options[this.selectedIndex].text);\">
			$options
		</select>";
		
		
		
		$t['total']  = "<input type='hidden' name='formulario[$colPos][setupForm]_mul' value='0'>". $template ."<input type='hidden' name='formulario[$colPos][setupForm]' value=''>";
			
		$t['total']  = str_replace("###comboOptions###",$comboOptions,$t['total']);
		$t['total']  = str_replace("###comboSelections###","<select size=10 multiple name='formulario[$colPos][setupForm]_list' style=\"width:".$this->conf['width']."px;\">".$options2."</select>",$t['total']);
	
		$t['total']  = str_replace("###actionRemove###","<a href='#' onClick=\"setFormValueManipulate('formulario[$colPos][setupForm]','Remove'); return false;\">",$t['total']);
		$t['total']  = str_replace("###actionUp###","<a href='#' onClick=\"setFormValueManipulate('formulario[$colPos][setupForm]','Up'); return false;\">",$t['total']);
		$t['total']  = str_replace("###colName###",$this->confInfo['colsNames'][$colPos],$t['total']);
	
		return $t['total'];
	
	}
	
	function saveCombo($colPos,$customize) {
		if ( strlen($_POST['formulario']['post']) != 0 ) {
			mysql_query ("DELETE FROM tx_gbcustomhome_tt_content_users WHERE colPosition = $colPos AND pid = $customize AND cruser_id = ".$this->userInfo['uid']);
			$selection=explode(",",$_POST['formulario'][$colPos]['setupForm']);
			$i=0;  $max=count($selection);
			$sorting = 0;
			while ($i < $max) {
				if ( is_numeric($selection[$i]) ) {
					$sorting = $sorting + 32;
					mysql_query  ("INSERT INTO `tx_gbcustomhome_tt_content_users` (`pid` ,`crdate` , `tstamp` ,`cruser_id` , `tt_content` , `sorting`, `colPosition` ) VALUES ('".$customize."', '".time()."', '".time()."', '".$this->userInfo['uid']."', '".$selection[$i]."', '$sorting', '$colPos');");
				}
				$i++;
			}
		}
	}
	function main($content,$conf)	{
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->userInfo = $GLOBALS["TSFE"]->fe_user->user;
	
		
		//Gets cache off
		$GLOBALS['TSFE']->set_no_cache();
				
		//If not have  info aboutt he user, or is a error or the feuser isnt logged
		if ( count($this->userInfo) <= 1 ) { return "<font color=red>ERROR!! This object only must be used by registered users, set the access minimun as \"Show at any login\"."; }
		//Check if no is setit customize var
		if ( strlen($conf['customize']) == 0 ) { return "<font color=red>ERROR!! You must set <b>plugin.tx_gbcustomhome.customize</b>, go to the template and edit this constant on the 'Constant Editor'"; }
		//Check if no is setit colpos var
		if ( strlen($conf['customize']) == 0 ) { return "<font color=red>ERROR!! You must set <b>plugin.tx_gbcustomhome.customizeCols</b>, go to the template and edit this constant on the 'Constant Editor'"; }
		//Get parsed the conf info
		$this->confInfo=ux_t3lib_DB::parseConfGB($conf);

		//If the exist info about the groud add a , for no parse error on mysql
		if (strlen($this->userInfo['usergroup']) != 0 ) { $this->userInfo['usergroup']=",".$this->userInfo['usergroup']; }

		if ( strlen($_GET['customize']) == 0 ) {
			$customizeUids=explode("/",$conf['customize']);
			$customize = $customizeUids[0];
		} else {
			$customize = $_GET['customize'];
		}
		
		//Load the template on the conf if not exist load the default template
		if ( strlen($conf['template']) == 0 ) { $conf['template']="EXT:".$this->extKey."/templates/setupForm.tmpl"; }
		$template = $this->cObj->fileResource($conf['template']);

		
		$javascript="
		<script>
		
		
		function setFormValueFromBrowseWin(fName,value,label)	{
				var formObj = setFormValue_getFObj(fName)
				if (formObj)	{
					fObj = formObj[fName+\"_list\"];
						// Inserting element
					var l=fObj.length;
					var setOK=1;
					if (!formObj[fName+\"_mul\"] || formObj[fName+\"_mul\"].value==0)	{
						for (a=0;a<l;a++)	{
							if (fObj.options[a].value==value)	{
								setOK=0;
							}
						}
					}
					if (setOK)	{
						fObj.length++;
						fObj.options[l].value=value;
						fObj.options[l].text=label;
		
							// Traversing list and set the hidden-field
						setHiddenFromList(fObj,formObj[fName]);
		
					}
				}
			}
			function setHiddenFromList(fObjSel,fObjHid)	{
				l=fObjSel.length;
				fObjHid.value=\"\";
				for (a=0;a<l;a++)	{
					fObjHid.value+=fObjSel.options[a].value+\",\";
				}
			}
			function setFormValueManipulate(fName,type)	{
		
				var formObj = setFormValue_getFObj(fName)
				if (formObj)	{
					var localArray_V = new Array();
					var localArray_L = new Array();
					var fObjSel = formObj[fName+\"_list\"];
					var l=fObjSel.length;
					var c=0;
					var cS=0;
					if (type==\"Remove\" || type==\"Up\")	{
						if (type==\"Up\")	{
							for (a=0;a<l;a++)	{
								if (fObjSel.options[a].selected==1)	{
									localArray_V[c]=fObjSel.options[a].value;
									localArray_L[c]=fObjSel.options[a].text;
									c++;
									cS++;
								}
							}
						}
						for (a=0;a<l;a++)	{
							if (fObjSel.options[a].selected!=1)	{
								localArray_V[c]=fObjSel.options[a].value;
								localArray_L[c]=fObjSel.options[a].text;
								c++;
							}
						}
					}
					fObjSel.length = c;
					for (a=0;a<c;a++)	{
						fObjSel.options[a].value = localArray_V[a];
						fObjSel.options[a].text = localArray_L[a];
						fObjSel.options[a].selected=(a<cS)?1:0;
					}
					setHiddenFromList(fObjSel,formObj[fName]);
					TBE_EDITOR_fieldChanged_fName(fName,formObj[fName+\"_list\"]);
				}
			}
			function setFormValue_getFObj(fName)	{
				var formObj = document.setupForm;
				if (formObj)	{
					if (formObj[fName] && formObj[fName+\"_list\"] && formObj[fName+\"_list\"].type==\"select-multiple\")	{
						return formObj;
					} else {
						alert(\"Formfields missing:\\n fName: \"+formObj[fName]+\"\\n fName_list:\"+formObj[fName+\"_list\"]+\"\\n type:\"+formObj[fName+\"_list\"].type+\"\\n fName:\"+fName);
					}
				}
				return \"\";
			}
		
		</script>";
		
		
		
		
		$t['total']  = $this->cObj->getSubpart($template,"###setupForm###");
		$t['total']  = str_replace("###formStart###","<form method=post id=setupForm name=setupForm><input name='formulario[post]' value='true' type='hidden'> ",$t['total']);
		$t['total']  = str_replace("###formEnd###","</form>",$t['total']);
		
		$t['total']  = str_replace("###javascript###",$javascript,$t['total']);
		$t['column']  = $this->cObj->getSubpart($template,"###columnCombos###");
		
		//Compose and save the combos for every col
		$i=0; $max=count($this->confInfo['cols']);
		while ($i < $max) {
			$s['###columnCombos###'].=$this->showCombos($this->confInfo['cols'][$i],$customize,$t['column']);
			$i++;
		}
		
		
		$salida=$this->cObj->substituteMarkerArrayCached($t['total'],array(),$s,array());
		return $this->pi_wrapInBaseClass($salida);
	}
}



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/gb_customhome/pi1/class.tx_gbcustomhome_pi1.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/gb_customhome/pi1/class.tx_gbcustomhome_pi1.php"]);
}

?>
